Subject: RE: Advanced Status Reporting and XML vs HTML

From: "Clemm, Geoff" <[email-masked]>
Date: Thu, 28 Dec 2000 00:33:47 -0500

The versioning extensions currently have over 100 403/409 sub-codes,
so we would either have to trim down the detail we can send back
to the client, or need an extension mechanism.  We are currently returning
an XML tag in the response body for 403/409.

Since XML is just a syntactic convention of where to put angle brackets,
I'd probably describe its weight as a rubber-band shooter level, rather
than bazooka (now CORBA, there's a bazooka :-).

As others have said, an additional header is only a few bytes, so I 
don't see that as a killer cost either, especially since the dispatching
off that header is only done at error reporting time.

Perhaps you could describe some of the other error extension mechanisms
you have in mind, so that we can compare their cost/benefit compared to
the one that Lisa has proposed?

Cheers,
Geoff

-----Original Message-----
From: Roy T. Fielding [mailto:[email-masked]]
Sent: Wednesday, December 20, 2000 9:18 PM
To: John Stracke
Cc: [email-masked]
Subject: Re: Advanced Status Reporting and XML vs HTML

On Wed, Dec 20, 2000 at 08:58:52AM -0500, John Stracke wrote:
> "Roy T. Fielding" wrote:
> 
> > Accept headers are a bad idea.  They have always been a bad idea.
> > A better solution is to provide the client with the primary content
> > choice and a means of obtaining the new content.
> 
> But, in this case, the content is an error message; this approach would
> require
> that the error message be stored on the server for a time, available at
(say)
> some other URL.  That's kind of an unpleasant requirement--especially if
the
> error that's being reported is "disk full".

That is why my message had more text than what you quoted above.

I currently do not believe that any error extension mechanism is
necessary, but even if it were to be necessary there are many ways
to include it that would only cost the application a couple bytes
on the response that would be ignored by anything not prepared
to handle it.  Therefore, generating a new standard for XML content
that describes an extension mechanism for status codes is not only
the equivalent of using a bazooka for domestic rodent control, it
also needlessly ties HTTP to XML responses.

....Roy